import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export interface IPerPageOption {
    number: number;
    text: string;
}
export interface ITableToolsLang {
    next: string;
    flipSelection: string;
    last: string;
    prev: string;
    csv: string;
    exportColumnNames: string;
    exportSeparator: string;
    exportChooseColumns: string;
    filteredResults: string;
    search: string;
    perPage: string;
    noResults: string;
    from: string;
    copiedToClipboard: string;
    copy: string;
    results: string;
    export: string;
    first: string;
    tabulator: string;
}
export interface IOrder {
    field: string;
    direction: 'asc' | 'desc';
}
export declare type operator = '>' | '<' | '>=' | '<=' | '==' | 'like';
export interface IFilterInstance {
    operator: operator;
    value: unknown;
}
export interface IFieldFilters {
    [fieldName: string]: {
        or: IFilterInstance[];
        and: IFilterInstance[];
    };
}
export declare type TableToolsResolver<T extends object> = (limit: number, offset: number, order: IOrder[], search: string, filters: IFieldFilters, url?: string) => Observable<ITableToolsResponse<T>>;
export interface ITableToolsExportType {
    lang: string;
    parseText?: (txt: string) => string;
    callback: (data: unknown[][], config: {
        fileName: string;
        columnNames: boolean;
        separator: string;
    }) => Observable<void>;
}
export interface ITableToolsResponse<T extends object> {
    data: T[];
    count: number;
    countFiltered: number;
}
export declare class TableToolsConfigService {
    protected document: Document;
    constructor(document: Document);
    perPage: number;
    perPageOptions: IPerPageOption[];
    lang: ITableToolsLang;
    defaultTableToolsResolver?: TableToolsResolver<any>;
    scroll: boolean;
    scrollOffset: number;
    exportTypes: {
        [name: string]: ITableToolsExportType;
    };
    exportNotification(type: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableToolsConfigService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TableToolsConfigService>;
}
